#include<bits/stdc++.h>

using namespace std;

const int MAXN = 1007;
const long double eps = 0.0001;

pair<long double, long double> p[MAXN];
long double d[MAXN];
long double arr[MAXN][MAXN];
int n;

long double dist(pair<long double, long double> a, pair<long double, long double> b)
{
    return (long double)sqrt((a.first - b.first)*(a.first - b.first) + (a.second - b.second)*(a.second  - b.second));
}

bool ok(long double a, long double b)
{
    if(fabs(a - b) < eps)
        return 1;

    return 0;
}

int binary_search_1(int ind, long double x)
{
    int l = -1, r = n-1, mid;

    while(l != r)
    {
        mid = (l+r+1)/2;

        if(arr[ind][mid] < x)
            l = mid;
        else
            r = mid-1;
    }

    return l;
}

int binary_search_2(int ind, long double x)
{
    int l = 0, r = n, mid;

    while(l != r)
    {
        mid = (l+r)/2;

        if(arr[ind][mid] > x)
            r = mid;
        else
            l = mid+1;
    }

    return l;
}

int main ()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int q;

    cin >> n >> q;

    for(int i = 0; i < n; i++)
        cin >> p[i].first >> p[i].second;

    for(int i = 0; i < n; i++)
        for(int j = 0; j < n; j++)
            arr[i][j] = dist(p[i], p[j]);

    for(int i = 0; i < n; i++)
        sort(arr[i], arr[i]+n);

    for(int i = 0; i < q; i++)
    {
        pair<long double, long double> x;

        cin >> x.first >> x.second;

        for(long long j = 0; j < n; j++)
            d[j] = dist(x, p[j]);

        sort(d, d+n);

        long long j = 0, res = 0;

        for(long long k = 0; k < n; k++)
        {
            while(!ok(d[k], d[j]))
                j++;

            res += k-j;
        }

        for(long long j = 0; j < n; j++)
        {
            long double curr_dist = dist(p[j], x);
            long long l = binary_search_1(j, curr_dist-eps);
            long long r = binary_search_2(j, curr_dist+eps);

            l++;
            r--;

            if(l > r)
                continue;

            res += r-l+1;
        }

        cout << res << "\n";
    }

    return 0;
}
