#include <cstdio>
#include <algorithm>
#include <cmath>

#define MAXN 1000

const double eps=0.0003;
const double e=1e-10;

using namespace std;

struct Point
{
  double x, y;
};

Point v[MAXN+5];
double dist[MAXN*MAXN+5];

inline double distance( Point a, Point b )
{
  return sqrt((a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y));
}

inline int comp( double a, double b )
{
  if( a-b<-e )
    return -1;

  if( a-b>e )
    return 1;

  return 0;
}

inline int bs( double k, int st, int dr )
{
  int mid, last=0;

  while( st<=dr )
  {
    mid=(st+dr)/2;

    if( comp(dist[mid],k)>=0 )
      dr=mid-1;
    else
    {
      st=mid+1;
      last=mid;
    }
  }

  return last;
}

int main()
{
  freopen( "triangle.in", "r", stdin );
  freopen( "triangle.out", "w", stdout );

  int n, q;

  scanf( "%d%d", &n, &q );

  for( int i=1;i<=n;i++ )
    scanf( "%lf%lf", &v[i].x, &v[i].y );

  while( q )
  {
    Point p;

    scanf( "%lf%lf", &p.x, &p.y );

    for( int i=1;i<=n;i++ )
        dist[i]=distance(v[i],p);

    sort(dist+1,dist+n+1);

    long long ans=0;

    for( int i=1;i<=n;i++ )
    {
      int pi=bs(dist[i]+eps,1,n);

      if( i<=pi )
        ans+=pi-i;
    }

    printf( "%lld\n", ans );

    q--;
  }

  return 0;
}
