#include <cstdio>
#include <algorithm>
#include <cmath>

#define MAXN 1000

const double eps=0.0001;

using namespace std;

struct Point
{
  double x, y;
};

Point v[MAXN+5];
double dist[MAXN+5];

inline double distance( Point a, Point b )
{
  return sqrt((a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y));
}

inline int comp( double a, double b )
{
  if( a-b<-eps )
    return -1;

  if( a-b>eps )
    return 1;

  return 0;
}

int main()
{
  int n, q;

  scanf( "%d%d", &n, &q );

  for( int i=1;i<=n;i++ )
    scanf( "%lf%lf", &v[i].x, &v[i].y );

  while( q )
  {
    Point p;

    scanf( "%lf%lf", &p.x, &p.y );

    for( int i=1;i<=n;i++ )
        dist[i]=distance(v[i],p);

    sort(dist+1,dist+n+1);

    int ans=0;

    for( int i=1;i<=n;i++ )
    {
      int pi=i+1;

      while( pi<=n && comp(dist[i],dist[pi])==0 )
        pi++;

      ans+=pi-i-1;
    }

    printf( "%d\n", ans );

    q--;
  }

  return 0;
}
