#include <cstdio>
#include <algorithm>
#include <cmath>

#define MAXN 1000

const double eps=0.0001;

using namespace std;

struct Point
{
  double x, y;
};

Point v[MAXN+5];
double dist[MAXN+5][MAXN+5];

inline double distance( Point a, Point b )
{
  return sqrt((a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y));
}

inline int comp( double a, double b )
{
  if( a-b<-eps )
    return -1;

  if( a-b>eps )
    return 1;

  return 0;
}

int main()
{
  int n, m=0, q;

  scanf( "%d%d", &n, &q );

  for( int i=1;i<=n;i++ )
    scanf( "%lf%lf", &v[i].x, &v[i].y );

  for( int i=1;i<=n;i++ )
    for( int j=i+1;j<=n;j++ )
      dist[i][j]=dist[j][i]=distance(v[i],v[j]);

  while( q )
  {
    Point p;

    scanf( "%lf%lf", &p.x, &p.y );

    int ans=0;

    for( int i=1;i<=n;i++ )
      for( int j=i+1;j<=n;j++ )
        if( comp(distance(p,v[i]),distance(p,v[j]))==0 || comp(distance(p,v[i]),dist[i][j])==0 || comp(dist[i][j],distance(p,v[j]))==0 )
          ans++;

    printf( "%d\n", ans );

    q--;
  }

  return 0;
}
