#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

const int N = 1009;
const double EPS = 1e-4, P = 1e-8;

pair < double, double > v[N], p[N];
long long ans[N];
vector < double > s[N], l[N];

double my_sqrt(double x) {
    double pas = (1<<19), r(0);
    while (pas > EPS) {
        if ((r + pas) * (r + pas) < x)
            r += pas;
        pas /= 2;
    }
    return r;
}

double dist(pair < double, double > a, pair < double, double > b) {
    return sqrt((long double)(a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second));
}

int cbs(int p, double val, int x) {
    int pas = 1<<9, r(-1);
    while (pas) {
        if (r + pas < x && s[p][r + pas] < val)
            r += pas;
        pas >>= 1;
    }
    return r + 1;
}

int cbl(int p, double val, int x) {
    int pas = (1<<9), r(-1);
    while (pas) {
        if (r + pas < x && l[p][r + pas] < val)
            r += pas;
        pas >>= 1;
    }
    return r + 1;
}

int main()
{
    int n, q;
    pair < double, double > a, b;
    cin >> n >> q;
    for (int i = 0; i < n; ++i)
        cin >> v[i].first >> v[i].second;
    for (int j = 0; j < q; ++j)
        cin >> p[j].first >> p[j].second;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            double d = dist(v[i], v[j]);
            s[i].push_back(d);
            s[j].push_back(d);
        }
        sort(s[i].begin(), s[i].end());
    }
    for (int i = 0; i < q; ++i) {
        for (int j = 0; j < n; ++j) {
            double d = dist(p[i], v[j]);
            int b = cbs(j, d + EPS + P, n - 1);
            int a = cbs(j, d - EPS, n - 1);
            int y = cbl(i, d + EPS + P, j);
            int x = cbl(i, d - EPS, j);
            ans[i] += b - a;
            ans[i] += y - x;
            l[i].push_back(d);
        }
    }
    for (int i = 0; i < q; ++i)
        cout << ans[i] << '\n';
    return 0;
}
