#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>

using namespace std;


int const nmax = 1000;
float const eps = 0.0001;

float dist(float x , float y , float x2 , float y2){
  return sqrt((x2 - x) * (x2 - x) + (y2 - y) * (y2 - y));
}

float v[5 + nmax][2];

float dist2[5 + nmax][5 + nmax];

float query[5 + nmax][2];

struct Incoming{
  int ind;
  float val;
  bool operator < (Incoming const &a) const{
    return val < a.val;
  }
};

vector<Incoming> incomingquery[5 + nmax];
vector<Incoming> incomingquery2[5 + nmax];

int sol[5 + nmax * 2];
int sol2[5 + nmax * 2];

int main()
{
  ios::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);

  int n , q;
  cin >> n >> q;
  for(int i = 1 ; i <= n ; i++)
    cin >> v[i][0] >> v[i][1];
  for(int i = 1 ; i <= n ; i++) {
    for(int j = 1 ; j <= n ; j++) {
      dist2[i][j] = (dist(v[i][0] , v[i][1] , v[j][0] , v[j][1]));
    }

    sort(dist2[i] , dist2[i] + n + 1);
  }

  for(int i = 1 ; i <= q ; i++){
    cin >> query[i][0] >> query[i][1];
    for(int j = 1 ; j <= n ;j++){
      float distmax = dist(query[i][0] , query[i][1] , v[j][0] , v[j][1]);
      incomingquery[j].push_back({i * 2, distmax + eps});
      incomingquery[j].push_back({i * 2 - 1, distmax - eps});
      incomingquery2[i].push_back({i * 2 , distmax + eps});
      incomingquery2[i].push_back({i * 2 - 1, distmax - eps});
    }
  }
  for(int i = 1 ; i <= n ;i++) {
    sort(incomingquery[i].begin() , incomingquery[i].end());
    int pos = 0;
    for(int j = 0 ;j < incomingquery[i].size() ; j++){
      while(pos < n && dist2[i][pos + 1] <= incomingquery[i][j].val)
        pos++;
      sol[incomingquery[i][j].ind] += pos;


    }
  }

  for(int i = 1 ; i <= q ; i++){
    float dist3[5 + nmax];
    sort(incomingquery2[i].begin() , incomingquery2[i].end());
    for(int j = 1 ; j <= n ; j++)
      dist3[j] = dist(v[j][0] , v[j][1] , query[i][0] , query[i][1]);
    sort(dist3 + 1 , dist3 + n + 1);

    int pos = 0;
    for(int j = 0 ; j < incomingquery2[i].size() ; j++){
      while(pos < n && dist3[pos + 1] <= incomingquery2[i][j].val)
        pos++;
      sol2[incomingquery2[i][j].ind] += pos;
    }
  }

  for(int i = 1 ; i <= q ; i++){
    int result = 0 , result2 = 0;

    result += sol[i * 2] - sol[i * 2 - 1];
    result2 += sol2[i * 2] - sol2[i * 2 - 1] - n;
    cout << result + result2 / 2 << '\n';

  }

  return 0;
}
/*
4 1
0.0 5.0
3.0 4.0
4.0 3.0
5.0 0.0
5.0 5.0
*/
