#include <iostream>
#include <unordered_map>
#include <vector>

using namespace std;

#define ll long long
#define MIN(a , b) (((a) < (b)) ? (a) : (b))
#define MAX(a , b) (((a) < (b)) ? (b) : (a))

int const nmax = 200000;
int const modulo = 998244353;
int const valmax = 100000000;

int v[5 + nmax];
int aint[5 + 4 * nmax];

int frec[5 + 2 * nmax];
int frec2[5 + 2 * nmax];

unordered_map<int , int> code;
unordered_map<int , int> decode;

int codep = 0;

vector<int> getcanditates(int from ,int to){
  vector<int> cand;
  int mid = (from + to) / 2;

  for(int i = from ; i <= to ; i++)
    frec2[v[i]] = 0;

  for(int i = mid + 1; i <= to ; i++)
    frec[v[i]] = 0;

  for(int i = mid + 1; i <= to ; i++){
    frec[v[i]]++;
    if((i - mid) / 2 < frec[v[i]])
      if(frec2[v[i]] == 0) {
        frec2[v[i]] = 1;
        cand.push_back(v[i]);
      }
  }

  for(int i = from ; i <= mid ; i++)
    frec[v[i]] = 0;

  for(int i = mid ; from <= i ; i--){
    frec[v[i]]++;
    if((mid - i + 1) / 2 < frec[v[i]])
      if(frec2[v[i]] == 0) {
        frec2[v[i]] = 1;
        cand.push_back(v[i]);
    }
  }

  return cand;
}

int solve( int from , int to ,int mid , int val){

  int mind = 0 , maxd = 0, sum = 0;
  for(int i = mid ; from <= i ; i--){
    if(v[i] == val)
      sum++;
    else
      sum--;
    mind = MIN(mind , sum);
    maxd = MAX(maxd , sum);
  }

  vector<int> diffcount;
  mind = -mind;

  diffcount.reserve(maxd + mind + 1);
  for(int i = 0 ; i <= maxd + mind ; i++)
    diffcount[i] = 0;

  sum = 0;
  for(int i = mid ; from <= i ; i--){
    if(v[i] == val)
      sum++;
    else
      sum--;
    diffcount[sum + mind] ++;
  }

  for(int i = maxd + mind - 1; 0 <= i ;i--)
    diffcount[i] += diffcount[i + 1];

  ll result = 0;

  sum = 0;


  for(int i = mid + 1 ; i <= to ;i++){
    if(v[i] == val)
      sum++;
    else
      sum--;


    if(0 <= -sum + mind + 1 && -sum + mind + 1 <= maxd + mind)
      result += diffcount[-sum + mind + 1];
    else if(-sum + mind + 1 < 0)
      result += diffcount[0];
  }
  //cout << ":" << ":" << result << ":" << '\n';

  return result;
}

int join(int from , int to , int mid){
  vector<int> cand = getcanditates(from , to);

  int result = 0;

  for(int i = 0 ; i < cand.size() ; i++) {
    result += 1LL * solve(from , to ,mid , cand[i]) * decode[cand[i]] % modulo;
    if(modulo <= result)
      result -= modulo;
  }
  return result;

}
void computenode(int node , int from , int to){
  int result = (aint[node * 2] + aint[node * 2 + 1]) % modulo;
  int mid = (from + to) / 2;
  aint[node] = (join(from , to , mid) + result) % modulo;
}



void build(int node ,int from , int to){
  if(from < to){
    int mid = (from + to) / 2;
    build(node * 2 , from ,mid);
    build(node * 2 + 1 , mid + 1 , to);
    computenode(node , from , to);
  } else {
    aint[node] = decode[v[from]] % modulo;
  }

}


void update(int node , int from , int to ,int x , int val){
  if(from < to){
    int mid = (from + to) / 2;
    if(x <= mid)
      update(node * 2 , from , mid , x , val);
    else
      update(node * 2 + 1 , mid + 1 ,to , x , val);
    computenode(node , from , to);

  } else{
    if(code[val] == 0) {
      code[val] = ++ codep;
      decode[codep] = val;
    }

    v[from] = code[val];
    aint[node] = decode[v[from]] % modulo;
  }
}

int query(int node , int from , int to , int x , int y){
  if(x == from && to == y){
    return aint[node];
  } else {
    int mid = (from + to) / 2;
    int result = 0;

    if(x <= mid)
      result += query(node * 2 , from , mid , x , MIN(y , mid));
    if(mid + 1 <= y) {
      result += query(node * 2 + 1 , mid + 1 , to , MAX(x , mid + 1) , y);
      if(modulo <= result)
        result -= modulo;
    }


    if(x <= mid && mid + 1 <= y) {
      result += join(x , y, mid);
      if(modulo <= result)
        result -= modulo;
    }
    return result;
  }
}
int main()
{
  int n;
  cin >> n;
  for(int i = 1 ; i <= n ; i++) {
    cin >> v[i];

    if(code[v[i]] == 0){
      code[v[i]] = ++codep;
      decode[codep] = v[i];

      v[i] = code[v[i]];
    } else
      v[i] = code[v[i]];

  }

  build(1 , 1 , n);


  int m;
  cin >> m;

  int last = 0;
  for(int i = 1 ; i <= m ; i++){
    int t , p , q;
    cin >> p >> q >> t;
    t = (t + last) % 2 + 1;
    if(t == 1){
      p = (p + last) % n + 1;
      q = (q + last) % valmax + 1;
      update(1 , 1 , n , p , q);
    } else {
      p = (p + last) % n + 1;
      q = (q + last) % n + 1;
      last = query(1 , 1 , n , p , q);
      cout << last << '\n';

    }
  }


  return 0;
}
