#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>

using namespace std;

#define ld long double
#define ll long long

#define MIN(a , b) (((a) < (b)) ? (a) : (b))
#define MAX(a , b) (((a) < (b)) ? (b) : (a))

int const nmax = 1000;
ld const eps = 0.0001;

ld dist(ld x , ld y , ld x2 , ld y2){
  return sqrt((x2 - x) * (x2 - x) + (y2 - y) * (y2 - y));
}

ld v[5 + nmax][2];

vector <ld> dist2[5 + nmax];

int binarysearch(int from ,int to , ld distmax , int node){
  if(from < to) {
    int mid = (from + to + 1) / 2;

    if(dist2[node][mid] <= distmax)
      return binarysearch(mid , to , distmax , node);
    else
      return binarysearch(from , mid - 1 , distmax , node);

  } else
    return from;
}

int main()
{
  int n , q;
  cin >> n >> q;
  for(int i = 1 ; i <= n ; i++)
    cin >> v[i][0] >> v[i][1];
  for(int i = 1 ; i <= n ; i++) {
    for(int j = 1 ; j <= n ; j++) {
      dist2[i].push_back(dist(v[i][0] , v[i][1] , v[j][0] , v[j][1]));
    }

    sort(dist2[i].begin() , dist2[i].end());
  }

  for(int i = 1 ; i <= q ; i++){
    ld x , y;
    ll result = 0;
    ll result2 = 0;

    cin >> x >> y;
    dist2[n + 1].clear();
    dist2[n + 1].push_back(0);

    for(int j = 1 ; j <= n ; j++) {
      dist2[n + 1].push_back(dist(x , y , v[j][0] , v[j][1]));
    }

    sort(dist2[n + 1].begin() , dist2[n + 1].end());


    for(int j = 1 ; j <= n ; j++){
      ///the edge between us and j exists
      ld distmax = dist(x , y , v[j][0] , v[j][1]);


      result += binarysearch(0 , dist2[j].size() - 1 , distmax + eps , j) -  binarysearch(0 , dist2[j].size() - 1 , distmax - eps , j);
      result2 += binarysearch(0 , dist2[n + 1].size() - 1 , distmax + eps , n + 1) - binarysearch(0 , dist2[n + 1].size() - 1 , distmax - eps , n + 1) - 1;
   }

    cout << result + result2 / 2 << '\n' ;
  }

  return 0;
}
