#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 2e5 + 7;
const int MOD = 998244353;

inline int mod(int n) {
    n %= MOD;
    if (n < 0) return n + MOD;
    else return n;
}

int tree[MAXN << 3], sum[MAXN << 3], add[MAXN << 3], f[MAXN << 3];

void build(int v, int tl, int tr) {
    if (tl == tr) {
        f[v] = -tl;
        return;
    }
    int tm = tl + ((tr - tl)>>1);
    build(v * 2 + 1, tl, tm); build(v * 2 + 2, tm + 1, tr);
    f[v] = f[v * 2 + 1] + f[v * 2 + 2];
}

void prec() {
    build(0, -MAXN, MAXN);
}

vector <int> vl;

void push(int v, int tl, int tr, int tm) {
    add[v * 2 + 1] += add[v];
    tree[v * 2 + 1] += add[v] * f[v * 2 + 1];
    tree[v * 2 + 1] = mod(tree[v * 2 + 1]);
    sum[v * 2 + 1] += add[v] * (tm - tl + 1);
    sum[v * 2 + 1] = mod(sum[v * 2 + 1]);

    add[v * 2 + 2] += add[v];
    tree[v * 2 + 2] += add[v] * f[v * 2 + 2];
    tree[v * 2 + 2] = mod(tree[v * 2 + 2]);
    sum[v * 2 + 2] += add[v] * (tr - tm);
    sum[v * 2 + 2] = mod(sum[v * 2 + 2]);

    add[v] = 0;
}

void relax(int v) {
    tree[v] = tree[v * 2 + 1] + tree[v * 2 + 2];
    sum[v] = sum[v * 2 + 1] + sum[v * 2 + 2];
}

void upd(int v, int tl, int tr, int l, int r, int x) {
    vl.push_back(v);
    if (tr < l || r < tl) return;
    if (l <= tl && tr <= r) {
        add[v] += x;
        sum[v] += x * (tr - tl + 1);
        tree[v] += f[v] * x;
        tree[v] = mod(tree[v]);
        return;
    }
    int tm = tl + ((tr - tl) >> 1);
    push(v, tl, tr, tm);
    upd(v * 2 + 1, tl, tm, l, r, x); upd(v * 2 + 2, tm + 1, tr, l, r, x);
    relax(v);
}

int get(int v, int tl, int tr, int l, int r) {
    vl.push_back(v);
    if (tr < l || r < tl) return 0;
    if (l <= tl && tr <= r) return tree[v];
    int tm = tl + ((tr - tl) >> 1);
    push(v, tl, tr, tm);
    return get(v * 2 + 1, tl, tm, l, r) + get(v * 2 + 2, tm + 1, tr, l, r);
}

int getsum(int v, int tl, int tr, int l, int r) {
    vl.push_back(v);
    if (tr < l || r < tl) return 0;
    if (l <= tl && tr <= r) {
        return sum[v];
    }
    int tm = tl + ((tr - tl) >> 1);
    push(v, tl, tr, tm);
    return getsum(v * 2 + 1, tl, tm, l, r) + getsum(v * 2 + 2, tm + 1, tr, l, r);
}

vector <int> p[MAXN];

int get_(int ps, int curr) {
    int l = curr - ps;
    int r = curr + 1;
    int ans = r * getsum(0, -MAXN, MAXN, l, r) + get(0, -MAXN, MAXN, l, r);
    ans += getsum(0, -MAXN, MAXN, -MAXN, l - 1) * (ps + 1);
    //cout << "get " << l << ' ' << getsum(0, -MAXN, MAXN, -MAXN, l - 1) << '\n';
    return ans;
}

void upd_(int ps, int curr) {
    int l = curr + 1 - ps;
    int r = curr + 1;
    upd(0, -MAXN, MAXN, l, r, 1);
}

int get(int n, int x) {
    for (auto v : vl) tree[v] = add[v] = sum[v] = 0;
    vl.clear();
    int ans = 0;
    int pr = p[x][0];
    upd(0, -MAXN, MAXN, -pr, 0, 1);
    int curr = -pr;
    for (int i = 0; i < p[x].size(); ++i) {
        int ps = 0;
        if (i + 1 < p[x].size()) ps = p[x][i + 1] - p[x][i] - 1;
        else ps = n - p[x][i] - 1;
        ans += get_(ps, curr);
        ans = mod(ans);
        upd_(ps, curr);
        curr += 1 - ps;
    }
    return ans;
}

int a[MAXN];
int tmp[MAXN];
int solve(int n) {
    for (int i = 0; i < n; ++i) tmp[i] = a[i];
    sort(tmp, tmp + n);
    int r = unique(tmp, tmp + n) - tmp;
    for (int i = 0; i < n; ++i) {
        a[i] = lower_bound(tmp, tmp + n, a[i]) - tmp;
    }
    for (int i = 0; i < n; ++i) p[i].clear();
    for (int i = 0; i < n; ++i) p[a[i]].push_back(i);
    int ans = 0;
    for (int i = 0; i < r; ++i) {
        ans += tmp[i] * get(n, i);
        ans = mod(ans);
    }
    return ans;
}

int arr[MAXN];

signed main() {
    //freopen("input.txt", "r", stdin);

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    prec();

    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) cin >> arr[i];

    int q;
    cin >> q;
    int add = 0;

    const int M = 100*1000*1000;

    for (int i = 0; i < q; ++i) {
        int l, r, t;
        cin >> l >> r >> t;
        t = (t + add) % 2 + 1;
        if (t == 1) {
            int p = (l + add) % n;
            int x = (r + add) % M + 1;
            arr[p] = x;
        }
        else {
            l = (l + add) % n; r = (r + add) % n;
            for (int j = l; j <= r; ++j) a[j - l] = arr[j];
            add = solve(r - l + 1);
            cout << add << '\n';
        }
    }

    return 0;
}
