#pragma GCC optimize("Ofast")
#pragma GCC target("tune=native")

#include <bits/stdc++.h>
using namespace std;

typedef double float80;

void solve();

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    auto start = chrono::high_resolution_clock::now();
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    solve();
#ifdef DEBUG
    auto finish = chrono::high_resolution_clock::now();
    chrono::duration<double> d = finish - start;
    cout << setprecision(3) << fixed << "Time: " << d.count() << "s\n";
#endif // DEBUG
    return 0;
}

const int MAX_N = 1000;

const float80 EPS = 1e-4;

struct Point {
    float80 x, y;
} points[MAX_N];

float80 dists[MAX_N], sdists[MAX_N];

float80 distsI[MAX_N][MAX_N];

float80 hypot2(float80 x, float80 y) {
    return sqrt(x * x + y * y);
}

void solve() {
    int n, q;
    float80 px, py;
    cin >> n >> q;
    for (int i = 0; i < n; ++i)
        cin >> points[i].x >> points[i].y;
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < n; ++j)
            distsI[i][j] = hypot2(points[i].x - points[j].x, points[i].y - points[j].y);
    for (int i = 0; i < n; ++i)
        sort(distsI[i], distsI[i] + n);
    for (int iteration = 0; iteration < q; ++iteration) {
        cin >> px >> py;
        int ans = 0;
        for (int i = 0; i < n; ++i)
            sdists[i] = dists[i] = hypot2(points[i].x - px, points[i].y - py);
        sort(dists, dists + n);
        float80 prev_dist = dists[0];
        int nop = 0;
        for (int i = 0; i < n; ++i) {
            if (fabs(prev_dist - dists[i]) < EPS)
                ++nop;
            else {
                ans += nop * (nop - 1);
                nop = 1;
                prev_dist = dists[i];
            }
        }
        ans += nop * (nop - 1);
        ans /= 2;
        for (int i = 0; i < n; ++i) {
            float80 distTo = sdists[i];
            int l1 = -1, r1 = n;
            while (r1 - l1 > 1) {
                int mid = (l1 + r1) / 2;
                if (distsI[i][mid] > distTo - EPS)
                    r1 = mid;
                else
                    l1 = mid;
            }
            int l2 = -1, r2 = n;
            while (r2 - l2 > 1) {
                int mid = (l2 + r2) / 2;
                if (distsI[i][mid] > distTo + EPS)
                    r2 = mid;
                else
                    l2 = mid;
            }
            int starts = r1;
            int ends = r2;
            ans += ends - starts;
        }
        cout << ans << "\n";
    }
}
