#include <bits/stdc++.h>
using namespace std;

const double EPS =   0.0001;

const int N = 1001;

double x[N], y[N];

double dx, dy;
inline double dist(int i, int j)
{
    dx = x[i] - x[j];
    dy = y[i] - y[j];
    return sqrt(dx * dx + dy * dy);
}

double ab, bc, ac;
bool good(int a, int b, int c)
{
    ab = dist(a, b);
    bc = dist(b, c);
    ac = dist(a, c);
    return fabs(ab - bc) < EPS || fabs(bc - ac) < EPS || fabs(ac - ab) < EPS;
}

bool double_less(double a, double b)
{
    return a < b - EPS;
}

bool double_equal(double a, double b)
{
    return fabs(a - b) < EPS;
}

int n, q, answer;
vector<double> d[N];

int f(int c)
{
    return c * (c - 1) / 2;
}

int32_t main()
{
    //freopen("input.txt", "r", stdin);
    ios::sync_with_stdio(0);
    cin.tie(nullptr);

    cin >> n >> q;

    for (int i = 0; i < n; ++i)
    {
        cin >> x[i] >> y[i];
    }

    for (int i = 0; i < n; ++i)
    {
        d[i].resize(n);
        for (int j = 0; j < n; ++j)
        {
            d[i][j] = dist(i, j);
        }
        sort(d[i].begin(), d[i].end());
    }

    d[n].resize(n);

    while (q--)
    {
        cin >> x[n] >> y[n];
        d[n].clear();
        for (int j = 0; j < n; ++j)
        {
            d[n].push_back(dist(n, j));
        }
        sort(d[n].begin(), d[n].end());

        answer = 0;

        double last = -1;
        int cnt = 0;

        for (double k : d[n])
        {
            if (double_equal(k, last))
            {
                ++cnt;
            }
            else
            {
                answer += f(cnt);
                last = k;
                cnt = 1;
            }
        }

        answer += f(cnt);

        for (int i = 0; i < n; ++i)
        {
            double need = dist(n, i);
            answer += upper_bound(d[i].begin(), d[i].end(), need, double_less) - lower_bound(d[i].begin(), d[i].end(), need, double_less);
        }

        cout << answer << '\n';
    }

    return 0;
}
