#include <bits/stdc++.h>
using namespace std;

const double EPS =   0.0001;

const int N = 1001;

const int ML = 200E6;
char allocated[ML], *pointer = allocated;
void * operator new(size_t n)
{
    char * res = pointer;
    pointer += n;
    return (void*)res;
}
void operator delete(void *) noexcept {}
void operator delete(void *, size_t) noexcept {}

double x[N], y[N];

double dx, dy;
inline double dist(int i, int j)
{
    dx = x[i] - x[j];
    dy = y[i] - y[j];
    return sqrt(dx * dx + dy * dy);
}

double ab, bc, ac;
bool good(int a, int b, int c)
{
    ab = dist(a, b);
    bc = dist(b, c);
    ac = dist(a, c);
    return fabs(ab - bc) < EPS || fabs(bc - ac) < EPS || fabs(ac - ab) < EPS;
}

bool double_less(double a, double b)
{
    return a < b - EPS;
}

bool double_equal(double a, double b)
{
    return fabs(a - b) < EPS;
}

int n, q, answer;
vector<double> d[N];

int f(int c)
{
    return c * (c - 1) / 2;
}

const int BUFF = 100E6;
char read_buf[BUFF], write_buff[BUFF];
int read_pos = 0, write_pos = 0;

inline char get_char()
{
    return read_buf[read_pos++];
}

char read_char()
{
    char c = get_char();
    while (c <= ' ')
    {
        c = get_char();
    }
    return c;
}

inline void write_char(char c)
{
    write_buff[write_pos++] = c;
}

double read_double()
{
    double res = 0;
    char c = read_char();
    while (c > ' ' && c != '.')
    {
        res = 10 * res + (c ^ 48);
        c = get_char();
    }
    double mul = 1;
    if (c == '.')
    {
        c = get_char();
        while (c > ' ')
        {
            mul *= 0.1;
            res += (c ^ 48) * mul;
            c = get_char();
        }
    }
    return res;
}

int read_int()
{
    int res = 0;
    char c = read_char();
    while (c > ' ')
    {
        res = 10 * res + (c ^ 48);
        c = get_char();
    }
    return res;
}

char str[30];
void write_int(int k)
{
    size_t p = 0;
    while (k || !p)
    {
        str[p++] = (k % 10) ^ 48;
        k /= 10;
    }
    while (p-- > 0)
    {
        write_char(str[p]);
    }
}

int32_t main()
{
    //freopen("input.txt", "r", stdin);

    fread(read_buf, 1, BUFF, stdin);

    n = read_int();
    q = read_int();

    for (int i = 0; i < n; ++i)
    {
        x[i] = read_double();
        y[i] = read_double();
    }

    for (int i = 0; i < n; ++i)
    {
        d[i].resize(n);
        for (int j = 0; j < n; ++j)
        {
            d[i][j] = dist(i, j);
        }
        sort(d[i].begin(), d[i].end());
    }

    d[n].resize(n);

    while (q--)
    {
        x[n] = read_double();
        y[n] = read_double();
        d[n].clear();
        for (int j = 0; j < n; ++j)
        {
            d[n].push_back(dist(n, j));
        }
        sort(d[n].begin(), d[n].end());

        answer = 0;

        double last = -1;
        int cnt = 0;

        for (double k : d[n])
        {
            if (double_equal(k, last))
            {
                ++cnt;
            }
            else
            {
                answer += f(cnt);
                last = k;
                cnt = 1;
            }
        }

        answer += f(cnt);

        for (int i = 0; i < n; ++i)
        {
            double need = dist(n, i);
            answer += upper_bound(d[i].begin(), d[i].end(), need) - lower_bound(d[i].begin(), d[i].end(), need);
        }

        write_int(answer);
        write_char('\n');
    }

    fwrite(write_buff, 1, write_pos, stdout);

    return 0;
}
