#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int ML = 200E6;
char allocated[ML], *pointer = allocated;
void * operator new(size_t n)
{
    char * res = pointer;
    pointer += n;
    return (void*)res;
}
void operator delete(void *) noexcept {}
void operator delete(void *, size_t) noexcept {}

namespace structure
{
unordered_map<int, int> cnt;
set<pair<int, int>> major;
int sum;

void add_number(int x)
{
    major.erase({cnt[x], x});
    ++cnt[x];
    major.insert({cnt[x], x});
    ++sum;
}
int get_major()
{
    assert(major.size());
    auto iter = major.rbegin();
    if (iter->first > (sum - iter->first))
    {
        return iter->second;
    }
    return 0;
}
void reset()
{
    sum = 0;
    cnt.clear();
    major.clear();
}
}


const int N     = 3E5;
const ll  MOD   = 998244353;

int n, m, last_output = 0, arr[N];

unordered_map<int, ll> cnt;

int query(int l, int r)
{
    ll answer = 0;
    cnt.clear();
    for (int start = l; start <= r; ++start)
    {
        structure::reset();
        for (int i = start; i <= r; ++i)
        {
            structure::add_number(arr[i]);
            ++cnt[structure::get_major()];
        }
    }
    for (const auto & pr : cnt) if (pr.first > 0)
    {
        answer += pr.first * pr.second;
        answer %= MOD;
    }
    return (int)answer;
}

int l, r, t, type, p, q;
const int MAX = 1E8;

int main()
{
    //freopen("input.txt", "r", stdin);
    ios::sync_with_stdio(0);
    cin.tie(nullptr);

    cin >> n;

    for (int i = 0; i < n; ++i)
    {
        cin >> arr[i];
    }

    cin >> m;

    for (int q_n = 0; q_n < m; ++q_n)
    {
        cin >> l >> r >> t;
        type = (t + last_output) % 2;
        if (type == 0)              /// Update.
        {
            p = ((l + last_output) % n);
            q = ((r + last_output) % MAX) + 1;
            arr[p] = q;
        }
        else                        /// Query.
        {
            p = ((l + last_output) % n);
            q = ((r + last_output) % n);
            last_output = query(p, q);
            cout << last_output << '\n';
        }
    }

    return 0;
}

