#include <bits/stdc++.h>

using namespace std;

typedef long long ll;


namespace structure
{
const int T = 3000;
int key[T], val[T];
int sum = 0, last = -1, cnt = 0;

void add_number(int x)
{
    ++sum;

    for (int i = x & 2047; i < T; ++i)
    {
        if (key[i] == 0)
        {
            key[i] = x;
            val[i] = 1;
            break;
        }
        if (key[i] == x)
        {
            ++val[i];
            break;
        }
    }

    if (cnt == 0)
    {
        last = x;
        cnt = 1;
        return;
    }
    if (x == last)
    {
        ++cnt;
    }
    else
    {
        --cnt;
    }
}
int get_major()
{
    int x = 0;
    for (int i = last % 2047; i < T; ++i)
    {
        if (key[i] == last)
        {
            x = val[i];
            break;
        }
    }
    if (x > (sum - x))
    {
        return last;
    }
    return -1;
}
void reset()
{
    sum = 0;
    last = -1;
    cnt = 0;
    fill(key, key + T, 0);
}
}


const int N     = 3E5;
const ll  MOD   = 998244353;

int n, m, last_output = 0, arr[N];

unordered_map<int, ll> cnt;

int query(int l, int r)
{
    ll answer = 0;
    cnt.clear();
    for (int start = l; start <= r; ++start)
    {
        structure::reset();
        for (int i = start; i <= r; ++i)
        {
            structure::add_number(arr[i]);
            ++cnt[structure::get_major()];
        }
    }
    for (const auto & pr : cnt) if (pr.first > 0)
    {
        answer += pr.first * pr.second;
    }
    return (int)(answer % MOD);
}

int l, r, t, type, p, q;
const int MAX = 1E8;

int main()
{
    //freopen("input.txt", "r", stdin);
    ios::sync_with_stdio(0);
    cin.tie(nullptr);

    cin >> n;

    for (int i = 0; i < n; ++i)
    {
        cin >> arr[i];
    }

    cin >> m;

    for (int q_n = 0; q_n < m; ++q_n)
    {
        cin >> l >> r >> t;
        type = (t + last_output) % 2;
        if (type == 0)              /// Update.
        {
            p = ((l + last_output) % n);
            q = ((r + last_output) % MAX) + 1;
            arr[p] = q;
        }
        else                        /// Query.
        {
            p = ((l + last_output) % n);
            q = ((r + last_output) % n);
            last_output = query(p, q);
            cout << last_output << '\n';
        }
    }

    return 0;
}

