#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>

#define sqr(x) ((x) * (x))
#define int ll

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<pii> vii;
typedef vector<vi> vvi;
typedef vector<char> vc;

const ld EPS = 1e-6;

struct dist{
	ld l;
	dist(int x, int y = 0) : l(sqrt(sqr(x) + sqr(y))) {};
	bool operator == (dist d){
		return abs(l - d.l) < EPS;
	}
	bool operator < (const dist d) const{
		return l < d.l - EPS;
	}
	bool operator >(const dist d) const{
		return l > d.l + EPS;
	}
};

signed main(){
#ifdef LOCALFILE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n, q;
	cin >> n >> q;
	vector<pair<ld, ld>> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i].first >> a[i].second;
	map <dist, int> m;
	for (int i = 0; i < n; ++i){
		for (int j = i; j < n; ++j){
			dist d = dist(a[i].first - a[j].first, a[i].second - a[j].second);
			if (m.find(d) == m.end())
				m[d] = 1;
			else
				++m[d];
		}
	}
	for (int i = 0; i < q; ++i){
		ld x, y;
		cin >> x >> y;
		map<dist, int> m1;
		int ans = 0;
		for (int j = 0; j < n; ++j){
			dist d = dist(x - a[j].first, y - a[j             ].second);
			if (m.find(d) != m.end()){
				ans += m[d];
			}
			if (m1.find(d) == m1.end())
				m1[d] = 1;
			else
				++m1[d];
		}
		for (auto j : m1){
			ans += j.second * (j.second - 1) / 2;
		}
		cout << ans << endl;
	}

	return 0;
}