#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <unordered_map>

#define sqr(x) ((x) * (x))
#define int unsigned long long
#define endl '\n'

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<pii> vii;
typedef vector<vi> vvi;
typedef vector<char> vc;

const ld EPS = 1e-6;

//struct dist{
//	ld l;
//	dist(ld x, ld y = 0) : l(sqrt(sqr(x) + sqr(y))) {};
//	bool operator == (dist d){
//		return abs(l - d.l) < EPS;
//	}
//	bool operator < (const dist d) const{
//		return l + EPS < d.l;
//	}
//	bool operator >(const dist d) const{
//		return l > d.l + EPS;
//	}
//};

int dist(int x, int y){
	return sqrt(sqr(x) + sqr(y));
}

signed main(){
#ifdef LOCALFILE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n, q;
	cin >> n >> q;
	vector<pair<int, int>> a(n);
	for (int i = 0; i < n; ++i){
		ld x, y;
		cin >> x >> y;
		a[i] = make_pair(x * 1e4, y * 1e4);
	}
	vector<unordered_map <int, int>> m(n);
	for (int i = 0; i < n; ++i){
		for (int j = i + 1; j < n; ++j){
			int d = dist(a[i].first - a[j].first, a[i].second - a[j].second);
			if (m[i].find(d) == m[i].end())
				m[i][d] = 1;
			else
				++m[i][d];
			if (m[j].find(d) == m[j].end())
				m[j][d] = 1;
			else
				++m[j][d];
		}
	}
	for (int i = 0; i < q; ++i){
		ld x1, y1;
		cin >> x1 >> y1;
		int x = x1 * 1e4;
		int y = y1 * 1e4;
		unordered_map<int, int> m1;
		int ans = 0;
		for (int j = 0; j < n; ++j){
			int d = dist(x - a[j].first, y - a[j].second);
			if (m[j].find(d) != m[j].end()){
				ans += m[j][d];
			}
			if (m1.find(d) == m1.end())
				m1[d] = 1;
			else
				++m1[d];
		}
		for (auto j : m1){
			ans += j.second * (j.second - 1) / 2;
		}
		cout << ans << endl;
	}

	return 0;
}